<?php // draw.php: chok(tue 9 jul 2002)



function draw_title( $title, $show_add=0, $button_href='', $button_text='' )
// specify $show_add=1 to show additional stuff, timestamp & refresh button
// $button_href and $button_text specifies a new button
{
	// for some pages, don't draw the ". ."
	$include_dots = ! $show_add;

	?>
	<table width=100%>
	<tr>
		<td width=30 nowrap>&nbsp;</td>
		<td align=left>
			<?php if($include_dots): ?>
			<font face=Verdana size=2 color=#d2d2d2>. &nbsp;</font>
			<font face=Verdana size=2 color=#bbbbbb>. &nbsp; &nbsp;</font>
			<?php endif; ?>

			<font face=Verdana size=2 color=#000055><b><?=$title;?></b></font>

			<?php if($include_dots): ?>
			<font face=Verdana size=2 color=#bbbbbb>&nbsp; &nbsp; .</font>
			<font face=Verdana size=2 color=#d2d2d2>&nbsp; .</font>
			<?php endif; ?>


			<?php if($show_add): ?>
			<br><font face=Arial size=1 color=#888888>
			Generated on <?=date('l, F j, Y, g:i:s a');?>
			</font>
			<?php endif;  ?>
		</td>
		<td align=right>
			<table>
			<tr>
    		<?php if($show_add):
            	global $PHP_SELF, $HTTP_GET_VARS, $HTTP_POST_VARS;
				?>
				<form action="<?=$PHP_SELF;?>">
				<?php
            	// save all vars
            	while( list($key,$val) = each($HTTP_POST_VARS) )
            		print("<input type=hidden name=$key value=\"$val\">");
            	while( list($key,$val) = each($HTTP_GET_VARS) )
            		print("<input type=hidden name=$key value=\"$val\">");
				?>
    		<td align=right>
    			<?=draw_submit_button('Refresh Page');?>
    		</td>
				</form>
    		<td width=30 nowrap>&nbsp;</td>
    		<?php endif; ?>


    		<?php if(strlen($button_href)): ?>
    		<form action="<?=$button_href;?>">
    		<td align=right><?=draw_submit_button($button_text);?></td>
    		</form>
    		<td width=30 nowrap>&nbsp;</td>
    		<?php endif; ?>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	<?php

	draw_hr();
}

function draw_hr()
// all horizontal rules in Ecescan are identical
{
	print('<hr noshade size=1 color=#dddddd>');
}

function draw_href( $href, $text, $mouseover, $mouseout, $add='' )
// simplify the drawing of a <a href>
// also appends 'return true;' to both $mouseover and $mouseout
// can add additional params to <a> using $add
{
	print(make_href( $href, $text, $mouseover, $mouseout, $add ));
}

function make_href( $href, $text, $mouseover, $mouseout, $add='' )
// this <a href> only works for the body_frame
{
	return "<a target=body_frame href=\"$href\" $add
		onMouseOver=\"$mouseover return true;\"
		onMouseOut=\"$mouseout return true;\">$text</a>";
}

function draw_buttons( $href, $label, $href2='', $label2='',
	$href3='', $label3='' )
// draw up to 3 buttons on the bottom of a page, drawing a <hr> first
{
	draw_hr();

	?>

	<table>
	<tr>
		<td width=30 nowrap>&nbsp;</td>
		<form action="<?=$href;?>">
		<td align=left><?=draw_submit_button($label);?></td>
		</form>

		<?php
		if( strlen($href2) ):
			?>
			<td width=30 nowrap>&nbsp;</td>
			<form action="<?=$href2;?>">
			<td align=left><?=draw_submit_button($label2);?></td>
			</form>
			<?php
		endif;
		?>

		<?php
		if( strlen($href3) ):
			?>
			<td width=30 nowrap>&nbsp;</td>
			<form action="<?=$href3;?>">
			<td align=left><?=draw_submit_button($label3);?></td>
			</form>
			<?php
		endif;
		?>
	</tr>
	</table>

	<?php
}

function draw_submit_button( $label )
{
	draw_button("type=submit value=\"$label\"");
}

function draw_jump_button( $href, $label, $mouseover, $mouseout,
	$width=0, $small=0 )
{
	$style = '';
	if($width) $style .= "width:$width;";
	if($small) $style .= 'font-size:7pt;';
	if($style) $style = "style=\"$style\"";

	draw_button("type=button value=\"$label\" $style onClick=\"
		window.location='$href'; return true;\" onMouseOver=\"
		$mouseover return true;\" onMouseOut=\"$mouseout return true;\"");
}

function draw_button( $button_attributes )
{
	?><table cellpadding=0 cellspacing=0 style=
		"border-left:solid 1px #fdfdfd; border-top:solid 1px #fdfdfd;">
	<tr>
		<td nowrap height=1 width=1></td>
		<td nowrap height=1 width=1 bgcolor=#7d99ae></td>
		<td nowrap height=1 width=1 bgcolor=#000000></td>
		<td nowrap height=1 bgcolor=#000000></td>
		<td nowrap height=1 width=1 bgcolor=#000000></td>
		<td nowrap height=1 width=1 bgcolor=#7d99ae></td>
		<td nowrap height=1 width=1></td>
	</tr>
	<tr>
		<td nowrap height=1 width=1 bgcolor=#7d99ae></td>
		<td nowrap height=1 width=1 bgcolor=#557da2></td>
		<td nowrap height=1 width=1 bgcolor=#c0cfdd></td>
		<td nowrap height=1></td>
		<td nowrap height=1 width=1 bgcolor=#c0cfdd></td>
		<td nowrap height=1 width=1 bgcolor=#557da2></td>
		<td nowrap height=1 width=1 bgcolor=#7d99ae></td>
	</tr>
	<tr>
		<td nowrap height=1 width=1 bgcolor=#000000></td>
		<td nowrap height=1 width=1 bgcolor=#c0cfdd></td>
		<td nowrap height=1 width=1></td>
		<td nowrap height=1 width=1></td>
		<td nowrap height=1 width=1></td>
		<td nowrap height=1 width=1 bgcolor=#c0cfdd></td>
		<td nowrap height=1 width=1 bgcolor=#000000></td>
	</tr>
	<tr>
		<td nowrap height=1 width=1 bgcolor=#000000></td>
		<td nowrap height=1 width=1></td>
		<td nowrap height=1 width=1></td>
		<td nowrap><input class=no_border <?=$button_attributes;?>></td>
		<td nowrap height=1 width=1></td>
		<td nowrap height=1 width=1></td>
		<td nowrap height=1 width=1 bgcolor=#000000></td>
	</tr>
	<tr>
		<td nowrap height=1 width=1 bgcolor=#7d99ae></td>
		<td nowrap height=1 width=1 bgcolor=#557da2></td>
		<td nowrap height=1 width=1 bgcolor=#c0cfdd></td>
		<td nowrap height=1></td>
		<td nowrap height=1 width=1 bgcolor=#c0cfdd></td>
		<td nowrap height=1 width=1 bgcolor=#557da2></td>
		<td nowrap height=1 width=1 bgcolor=#7d99ae></td>
	</tr>
	<tr>
		<td nowrap height=1 width=1></td>
		<td nowrap height=1 width=1 bgcolor=#7d99ae></td>
		<td nowrap height=1 width=1 bgcolor=#000000></td>
		<td nowrap height=1 bgcolor=#000000></td>
		<td nowrap height=1 width=1 bgcolor=#000000></td>
		<td nowrap height=1 width=1 bgcolor=#7d99ae></td>
		<td nowrap height=1 width=1></td>
	</tr>
	</table><?php
}

function draw_key_values( $arr, $columns=0 )
// draws a fancy table that shows data, uses up to 3 columns by auto-decision
// $arr = array(array($key,$value),array($key,$value),...)
// specify $columns to prevent auto-decision
{
	// determine no of columns to display in
	$count = sizeof($arr);
	if($columns):
		$cols = $columns;
	else:
		// auto-decision, up to 3 maximum
  	$cols = 1;
  	if($count > 3) $cols = 2;
  	if($count > 6) $cols = 3;
	endif;

	// calculate no of rows in each column
	$rows_till_this_col = array(0);
	$min_rows_per_col = $count / $cols;
	$remainder = $count % $cols;
	for( $i=1; $i<$cols; $i++, $remainder-- ):
		$rows_till_this_col[$i] = $min_rows_per_col + $rows_till_this_col[$i-1];
		if($remainder) $rows_till_this_col[$i] ++;
	endfor;

	// draw out the tables
	print('<table cellpadding=3 cellspacing=0>');

	$td1 = '<td bgcolor=#fafafa nowrap align=left valign=center';
	$td2 = '<td bgcolor=#ffffff align=left valign=center';
	$border = 'solid 1px #dddddd';
	$bottom_right = "border-bottom:$border; border-right:$border;";
	$bottom_right_left = $bottom_right . "border-left:$border;";
	$font1 = 'font-face:Arial; font-size:7pt; color:#0000aa; font-weight:bold;';
	$font2 = 'font-face:Arial; font-size:7pt; color:#555555;';

	$tab11 = "<table cellpadding=0 cellspacing=0 bgcolor=#fafafa>
		<tr><td width=15 nowrap>&nbsp;</td>$td1 style=\"$font1\">";
	$tab12 = '</td><td width=15 nowrap>&nbsp;</td></tr></table>';

	$tab21 = "<table cellpadding=0 cellspacing=0 bgcolor=#ffffff>
		<tr><td width=10 nowrap>&nbsp;</td>$td2 style=\"$font2\">";
	$tab22 = '</td><td width=10 nowrap>&nbsp;</td></tr></table>';

	// print out data
	for( $i=$row=0; $i<$count; $row++ ):
		print('<tr>');
		for( $col=0; $i<$count && $col<$cols; $i++, $col++ ):
			// print a gap before the previous stuff
			if($col) print("<td width=30 nowrap>&nbsp;</td>");

			// determine the borderings
			$top = ($row? '' : "border-top:$border;");
			$style1 = "style=\"$bottom_right_left $top $font1\"";
			$style2 = "style=\"$bottom_right $top $font2\"";

			// print the data
			$index = $rows_till_this_col[$col] + $row;
			$key = strlen($arr[$index][0])? $arr[$index][0] : 'Nil';
			$val = strlen($arr[$index][1])? $arr[$index][1] : 'Nil';
			print("$td1 $style1>${tab11}${key}${tab12}</td>");
			print("$td2 $style2>${tab21}${val}${tab22}</td>");
		endfor;
		print('</tr>');
	endfor;

	print('</table>');
}

?>
